"use strict";

exports.__esModule = true;
exports.default = exportDefault;

var _fs = _interopRequireDefault(require("fs"));

var _shelljs = _interopRequireDefault(require("shelljs"));

var _path = _interopRequireDefault(require("path"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const open = (0, _util.promisify)(_fs.default.open);
const writeFile = (0, _util.promisify)(_fs.default.writeFile);
/**
 * Takes a path and some content and performs a write call. Simple.
 */

async function exportDefault(fileName, output, _index) {
  const folderName = _path.default.dirname(fileName);

  let handle;

  try {
    handle = await open(fileName, "w");
  } catch {
    _shelljs.default.mkdir("-p", folderName);

    handle = await open(fileName, "w");
  }

  await writeFile(handle, output);
  return fileName;
}