"use strict";

exports.__esModule = true;
exports.withEnv = withEnv;
let i = 0;
const envs = {};

function withEnv(callback) {
  function fn(...args) {
    return callback(envs[i - 1], ...args);
  }

  fn.withEnv = env => {
    envs[i] = env;
    i++;
    return (...args) => {
      return callback(env, ...args);
    };
  };

  return fn;
}